# coding: Shift_JIS
import cv2
import math
import numpy as np

file_src1 = 'src1.png'
file_src2 = 'src2.png'
file_src3 = 'src3.png'
file_dst = 'dst.png'

img_src1 = cv2.imread(file_src1, 0)
img_src2 = cv2.imread(file_src2, 0)
img_src3 = cv2.imread(file_src3, 0)

cv2.namedWindow('src1')
cv2.namedWindow('src2')
cv2.namedWindow('src3')
cv2.namedWindow('dst')


# img_src1  摜 A(  t Ɏ擾 )
# img_src2  摜 B(  t+1 Ɏ擾 )
# img_src3  摜 C(  t+2 Ɏ擾 )
# 摜 A  B ̍摜vZ
img_df1 = cv2.absdiff(img_src1, img_src2)
# 摜 B  C ̍摜vZ
img_df2 = cv2.absdiff(img_src2, img_src3)
# ꂼ̍摜l
img_df1b = cv2.threshold(img_df1, 20, 255, cv2.THRESH_BINARY)[1]
img_df2b = cv2.threshold(img_df2, 20, 255, cv2.THRESH_BINARY)[1]
# lꂽ摜̋ʕ擾
img_m = cv2.bitwise_and(img_df1b, img_df2b)
# cEkă}XN摜𐶐
op = np.ones((3, 3), np.uint8)
img_md = cv2.dilate(img_m, op, iterations = 3)
img_msk = cv2.erode(img_md, op, iterations = 3)
# }XN
img_dst = cv2.bitwise_and(img_src2, img_msk)

cv2.imshow('src1', img_src1) # ͉摜1\
cv2.imshow('src2', img_src2) # ͉摜2\
cv2.imshow('src3', img_src3) # ͉摜3\
cv2.imshow('dst', img_dst) # o͉摜\
cv2.imwrite(file_dst, img_dst); # ʂ̕ۑ

cv2.waitKey(0) # L[͑҂
cv2.destroyAllWindows()
