# coding: Shift_JIS
import cv2
import math
import numpy as np

file_src = 'src.png'
file_dst = 'dst.png'

img_src = cv2.imread(file_src, 0)

cv2.namedWindow('src')
cv2.namedWindow('dst')

contours,  hierarchy = cv2.findContours(img_src, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)
area = cv2.contourArea(contours[0])
perimeter = cv2.arcLength(np.array(contours[0]), True)
roundness = 4 * np.pi * area / perimeter / perimeter
print area, perimeter, roundness

cv2.imshow('src', img_src) # ͉摜\
#cv2.imshow('dst', img_dst) # o͉摜\
#cv2.imwrite(file_dst, img_dst); # ʂ̕ۑ

cv2.waitKey(0) # L[͑҂
cv2.destroyAllWindows()
